function featureConvolution(featureVersion,scale,overwrite)
% Pre-computation of S1 maps. Save them on the hard drive.

if nargin < 2
    overwrite = 1;
end

windowSize = 150; % size of template window
Upperbound = 6; % upperbound for Gabor response
norient = 16; % number of Gabor orientations
Lrange = 6; sub = 1; Orange = 1; % local deformation parameters

% all positive images are inscribed in a 150*150 square
allfilter = makefilter(scale,norient);

% size of local average operator:
localHalfx = floor(size(allfilter{1},1)*1.2);

maxImArea = 1000 * 1000;


%% natural images
load('Split/Natural/split.mat','negTestImages','negTrainImages');
rescale = -1;

if ~exist(sprintf('Feature/%s/Natural',featureVersion),'dir')
    mkdir(sprintf('Feature/%s/Natural',featureVersion));
end

imageNames = negTestImages;
n = length(imageNames);
for i = 1:n
    imagePath = sprintf('Image/%s/%s','Natural',imageNames{i});
    % below: need to add a branch over feature versions
    dumpFeature_GaborS1(featureVersion,overwrite,rescale,windowSize,imagePath,allfilter,maxImArea,localHalfx,...
		Lrange, Orange, sub, Upperbound);
end

imageNames = negTrainImages;
n = length(imageNames);
for i = 1:n
    imagePath = sprintf('Image/%s/%s','Natural',imageNames{i});
    dumpFeature_GaborS1(featureVersion,overwrite,rescale,windowSize,imagePath,allfilter,maxImArea,localHalfx,...
		Lrange, Orange, sub, Upperbound);
end

%% positive example images
rescale = 1;

load('Split/categoryInfo.mat','categories','nCat');
iRun = 1;
for iCat = 1:nCat
    load(sprintf('Split/%s/split%d.mat',categories{iCat},iRun),...
            'posTrainImages','posTestImages');
        
    if ~exist(sprintf('Feature/%s/%s',featureVersion,categories{iCat}),'dir')
        mkdir(sprintf('Feature/%s/%s',featureVersion,categories{iCat}));
    end

    imageNames = posTrainImages;
    n = length(imageNames);
    for i = 1:n
        imagePath = sprintf('Image/%s/%s',categories{iCat},imageNames{i});
        dumpFeature_GaborS1(featureVersion,overwrite,rescale,windowSize,imagePath,allfilter,maxImArea,localHalfx,...
			Lrange, Orange, sub, Upperbound);
    end

    imageNames = posTestImages;
    n = length(imageNames);
    for i = 1:n
        imagePath = sprintf('Image/%s/%s',categories{iCat},imageNames{i});
        dumpFeature_GaborS1(featureVersion,overwrite,rescale,windowSize,imagePath,allfilter,maxImArea,localHalfx,...
			Lrange, Orange, sub, Upperbound);
    end
end
