% going over all methods, categories and repeition runs 

load('Split/categoryInfo.mat','categories');
load('Split/Natural/split.mat','negTestImages');
% categories = categories(1:20);
nC = length(categories);
overwrite = false;
featureConvolution('GaborS1',overwrite);

cd Code
mex mexc_SharedSketch.cpp
mex mexc_ComputeSUM2.cpp
mex mexc_ComputeMAX1.cpp
mex mexc_Copy.cpp
mex mexc_TemplateAffineTransform.cpp
mex mexc_CropInstance.cpp
cd ..

% natural stat
%tilt_GaborS1

%
% learning
%

for iCat = [1 21:nC]
     for iRun = 11
         %
         % learn a template
         %
         experiment = ActiveBasisLocalNorm(iRun,iCat,categories);
         experiment.learn; % calls the class method learn(this) of ActiveBasisLocalNorm 
         clear experiment
     end
end



% 
% testing
%

iCat = 1;
for iRun = 11
    %
    % learn a template
    %
    experiment = ActiveBasisLocalNorm(iRun,iCat,categories);
    experiment.test_multiclass; % calls the class method learn(this) of ActiveBasisLocalNorm 
    clear experiment
end


%
% evaluating
%
for iRun = 11
     numImage = 0;
     for iCat = 1:nC
         load(sprintf('Split/%s/split%d.mat',categories{iCat},iRun),'posTestImages');
         pos{iCat} = numImage + (1 : length(posTestImages));
         numImage = numImage + length(posTestImages);
     end
     

     tssMat = zeros(numImage,nC,'single');
     offset = 0;
     for iCat = 1:nC
         load(sprintf('Result/%s/ActiveBasisLocalNorm/out_run%d.mat', categories{iCat}, iRun),'scores');
         for i = 1:length(pos{iCat})
             tssMat(offset+i,:) = scores{i}(1,:);
         end
         offset = offset + length(pos{iCat});
     end
     
     [averageRate confusionMatrix correctRate] = getConfusionMatrix(tssMat,pos);

 end

mkdir('Result/summary/GaborS1');
save(sprintf('%s/eval_result.mat','Result/summary/GaborS1'), 'averageRate', 'confusionMatrix', 'correctRate');


