% going over all methods, categories and repeition runs 

load('Split/categoryInfo.mat','categories');
load('Split/Natural/split.mat','negTestImages');
% categories = categories(2);
nC = length(categories);
overwrite = true;
%featureConvolution('GaborS1',0.7,overwrite);
%featureConvolution('GaborS1_11',0.4,overwrite);
%featureConvolution('GaborS1_25',1,overwrite);

cd Code
mex Ctransform.c
mex Cmax.c
mex Chistog.c
mex mexc_SharedSketch.cpp
mex mexc_ComputeSUM2.cpp
mex mexc_ComputeMAX1.cpp
mex mexc_Copy.cpp
mex mexc_TemplateAffineTransform.cpp
mex mexc_CropInstance.cpp
cd ..

% natural stat
% tilt_GaborS1

%
% learning
%

for iCat = 1:nC
     for iRun = 11
         %
         % learn a template
         %
         experiment = SketchTextureFlat(iRun,iCat,categories);
         experiment.learn; % calls the class method learn(this) of ActiveBasisLocalNorm 
         clear experiment
     end
end


%
% visualize the templates
%
for iRun = 11
    % sketch template
	symbolicTemplates = cell(1,nC);
	nSketchToDisplay = 45;
	for iCat = 1:nC
		load(sprintf('Result/%s/SketchTextureFlat/model_run%d.mat', categories{iCat}, iRun), 'sym',...
			'Mx','My','Mi','Mm');
		sym = displayGaborTemplate(size(sym), Mx(1:nSketchToDisplay),...
			My(1:nSketchToDisplay), Mi(1:nSketchToDisplay), Mm(1:nSketchToDisplay) );
		symbolicTemplates{iCat} = double(sym);
	end
	templates_sym = displayImages(symbolicTemplates,10,100,100);
	if ~exist('Result/summary/SketchTextureFlat', 'dir')
		mkdir('Result/summary/SketchTextureFlat');
	end
	imwrite(templates_sym,sprintf('%s/templates_run%d.png','Result/summary/SketchTextureFlat', iRun));
    
    % texture template
    symbolicTemplates = cell(1,nC);
	nTextureToDisplay = 30;
	for iCat = 1:nC
		load(sprintf('Result/%s/SketchTextureFlat/model_run%d.mat', categories{iCat}, iRun), 'S2TemplateTexture'...
			);
		Mx = S2TemplateTexture.selectedRow(1:min(end,nTextureToDisplay)) + 1 + floor(size(sym,1)/2);
		My = S2TemplateTexture.selectedCol(1:min(end,nTextureToDisplay)) + 1 + floor(size(sym,2)/2);
		Mi = S2TemplateTexture.selectedOri(1:min(end,nTextureToDisplay));
		sym = displayGaborTemplate(size(sym), Mx,...
			My,...
            Mi,...
            ones(1,length(Mx))...
            );
		symbolicTemplates{iCat} = double(sym);
	end
	templates_sym = displayImages(symbolicTemplates,10,100,100);
	if ~exist('Result/summary/SketchTextureFlat', 'dir')
		mkdir('Result/summary/SketchTextureFlat');
	end
	imwrite(templates_sym,sprintf('%s/templatesTex_run%d.png','Result/summary/SketchTextureFlat', iRun));
end

% 
% validation on training data: to obtain p(label|template)
%

iCat = 1;
for iRun = 11
    experiment = SketchTextureFlat(iRun,iCat,categories);
    experiment.test_on_train_multiclass; % calls the class method learn(this) of ActiveBasisLocalNorm 
    clear experiment
end


% 
% testing
%

for iRun = 11
    experiment = SketchTextureFlat(iRun,1,categories);
    experiment.test_multiclass; % calls the class method learn(this) of ActiveBasisLocalNorm 
    clear experiment
end


%
% post processing by Bayesian voting
%
for iRun = 11
    experiment = SketchTextureFlat(iRun,1,categories);
    experiment.post_process; % calls the class method learn(this) of ActiveBasisLocalNorm 
    clear experiment
end


%
% post processing by SVM
%
%{
for iRun = 11
    experiment = SketchTextureFlat(iRun,1,categories);
    experiment.post_process_svm; % calls the class method learn(this) of ActiveBasisLocalNorm 
    clear experiment
end
%}

%
% evaluating
%
for iRun = 11
     numImage = 0;
     for iCat = 1:nC
         load(sprintf('Split/%s/split%d.mat',categories{iCat},iRun),'posTestImages');
         pos{iCat} = numImage + (1 : length(posTestImages));
         numImage = numImage + length(posTestImages);
     end
     
     tssMat = zeros(numImage,nC,'single');
     offset = 0;
     for iCat = 1:nC
         %load(sprintf('Result/%s/SketchTextureFlat/out_run%d.mat', categories{iCat}, iRun),'scores');
         load(sprintf('Result/%s/SketchTextureFlat/out_run%d.mat', categories{iCat}, iRun),'post_label_given_image','scores');
         scores = post_label_given_image;
         for i = 1:length(pos{iCat})
             tssMat(offset+i,:) = scores{i}(1,1:nC);
         end
         offset = offset + length(pos{iCat});
     end
     
     [averageRate confusionMatrix correctRate] = getConfusionMatrix(tssMat,pos);


	if ~exist('Result/summary/SketchTextureFlat', 'dir')
		mkdir('Result/summary/SketchTextureFlat');
	end
	save(sprintf('%s/eval_result_run%d.mat','Result/summary/SketchTextureFlat', iRun), 'averageRate', 'confusionMatrix', 'correctRate', 'tssMat');
end

%{
for iRun = 11
     numImage = 0;
     for iCat = 1:nC
         load(sprintf('Split/%s/split%d.mat',categories{iCat},iRun),'posTrainImages');
         pos{iCat} = numImage + (1 : length(posTrainImages));
         numImage = numImage + length(posTrainImages);
     end
     
     tssMat = zeros(numImage,nC,'single');
     offset = 0;
     for iCat = 1:nC
         load(sprintf('Result/%s/SketchTextureFlat/out_run%d.mat', categories{iCat}, iRun),'post_label_given_image_train', 'scores_train');
         scores = scores_train;
		 scores = post_label_given_image_train;
         for i = 1:length(pos{iCat})
             tssMat(offset+i,:) = scores{i}(1,1:nC);
         end
         offset = offset + length(pos{iCat});
     end

     [averageRate confusionMatrix correctRate] = getConfusionMatrix(tssMat,pos);

	 
	if ~exist('Result/summary/SketchTextureFlat', 'dir')
		mkdir('Result/summary/SketchTextureFlat');
	end
	save(sprintf('%s/eval_train_result_run%d.mat','Result/summary/SketchTextureFlat', iRun), 'averageRate', 'confusionMatrix', 'correctRate', 'tssMat');
end

%}
