function tilt_GaborS1

Upperbound = 6.; % saturation value
binsize = .2;  % binsize for computing F
scale = .7;
norient = 16;
load('Split/Natural/split.mat');

n = length(negTrainImages);
allfilter = makefilter(scale, norient);  % generate Gabor filters 
h = (size(allfilter{1}, 1)-1)/2;  % half size of Gabor


%% S1LocalNorm
allfiltered = cell(n,norient);
imsize = zeros(n,2);
for i = 1:n
    load(sprintf('Feature/GaborS1/%s/%s.mat',...
        'Natural',negTrainImages{i}),'S1LocalNorm','RANGE');
    S1LocalNorm = convert2float(S1LocalNorm,RANGE);
    for o = 1:norient
        allfiltered{i,o} = single( S1LocalNorm{o} );
    end
    imsize(i,:) = size(allfiltered{i,1});
end

binnum = floor(Upperbound/binsize)+1;  % binnumbers
histog = zeros(binnum, 1);  % store F  

% MEX-C %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tic
disp('start histogramming');
Chistog(n, norient, allfiltered, h, imsize(:,1), imsize(:,2), binsize, binnum, histog, Upperbound);
disp(['histogramming time: ' num2str(toc) ' seconds']);

% RESULTS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
r = (0:(binnum-1))*binsize;

M = 50; 
e = zeros(M, 1);
Z = zeros(M, 1); 
for k=1:M
    lambda = (k-1.)/10.;
    p = exp(lambda*r).*(histog'); 
    Z(k) = sum(p*binsize); p = p/Z(k);
    %plot(r, p); 
    e(k) = sum(r.*p*binsize);
end
lam = (0:(M-1))/10.; 
lz = log(Z);

save(sprintf('Feature/naturalStat_GaborS1_LocalNorm.mat'), 'M',...
    'lam', 'e', 'lz', 'Upperbound', 'scale', 'norient', 'histog');

clear S1LocalNorm;

%% S1LocalNormPerOri
allfiltered = cell(n,norient);
imsize = zeros(n,2);
for i = 1:n
    load(sprintf('Feature/GaborS1/%s/%s.mat',...
        'Natural',negTrainImages{i}),'S1LocalNormPerOri','RANGE');
    S1LocalNormPerOri = convert2float(S1LocalNormPerOri,RANGE);
    for o = 1:norient
        allfiltered{i,o} = single( S1LocalNormPerOri{o} );
    end
    imsize(i,:) = size(allfiltered{i,1});
end

binnum = floor(Upperbound/binsize)+1;  % binnumbers
histog = zeros(binnum, 1);  % store F  

% MEX-C %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tic
disp('start histogramming');
Chistog(n, norient, allfiltered, h, imsize(:,1), imsize(:,2), binsize, binnum, histog, Upperbound);
disp(['histogramming time: ' num2str(toc) ' seconds']);

% RESULTS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
r = (0:(binnum-1))*binsize;

M = 50; 
e = zeros(M, 1); 
Z = zeros(M, 1); 
for k=1:M
    lambda = (k-1.)/10.;
    p = exp(lambda*r).*(histog'); 
    Z(k) = sum(p*binsize); p = p/Z(k);
    %plot(r, p); 
    e(k) = sum(r.*p*binsize);
end
lam = (0:(M-1))/10.; 
lz = log(Z);

save(sprintf('Feature/naturalStat_GaborS1_LocalNormPerOri.mat'), 'M',...
    'lam', 'e', 'lz', 'Upperbound', 'scale', 'norient', 'histog');
clear S1LocalNormPerOri


%% S1LocalMean

allfiltered = cell(n,norient);
imsize = zeros(n,2);
for i = 1:n
    load(sprintf('Feature/GaborS1/%s/%s.mat',...
        'Natural',negTrainImages{i}),'S1LocalMean','RANGE');
    S1LocalMean = convert2float(S1LocalMean,RANGE);
    for o = 1:norient
        allfiltered{i,o} = single( S1LocalMean{o} );
    end
    imsize(i,:) = size(allfiltered{i,1});
end

binnum = floor(Upperbound/binsize)+1;  % binnumbers
histog = zeros(binnum, 1);  % store F

% MEX-C %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tic
disp('start histogramming');
Chistog(n, norient, allfiltered, h, imsize(:,1), imsize(:,2), binsize, binnum, histog, Upperbound);
disp(['histogramming time: ' num2str(toc) ' seconds']);

% RESULTS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
r = (0:(binnum-1))*binsize;

M = 50;
e = zeros(M, 1); 
Z = zeros(M, 1); 
for k=1:M
    lambda = (k-1.)/20.;
    p = exp(lambda*r).*(histog'); 
    Z(k) = sum(p*binsize); p = p/Z(k);
    e(k) = sum(r.*p*binsize);
end
lam = (0:(M-1))/20.;
lz = log(Z);

save(sprintf('Feature/naturalStat_GaborS1_LocalMean.mat'), 'M',...
    'lam', 'e', 'lz', 'Upperbound', 'scale', 'norient', 'histog');

clear allfiltered
clear S1LocalMean


%% S1LocalFlat
allfiltered = cell(n,norient);
imsize = zeros(n,2);
for i = 1:n
    load(sprintf('Feature/GaborS1/%s/%s.mat',...
        'Natural',negTrainImages{i}),'S1LocalMeanOverOrientation','RANGE');
    S1LocalMeanOverOrientation = convert2float(S1LocalMeanOverOrientation,RANGE);
    for o = 1:norient
        allfiltered{i,o} = single( Upperbound - S1LocalMeanOverOrientation );
    end
    imsize(i,:) = size(allfiltered{i,1});
end

binnum = floor(Upperbound/binsize)+1;  % binnumbers
histog = zeros(binnum, 1);  % store F

% MEX-C %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tic
disp('start histogramming');
Chistog(n, norient, allfiltered, h, imsize(:,1), imsize(:,2), binsize, binnum, histog, Upperbound);
disp(['histogramming time: ' num2str(toc) ' seconds']);

% RESULTS %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
r = (0:(binnum-1))*binsize;

M = 50;
e = zeros(M, 1); 
Z = zeros(M, 1); 
for k=1:M
    lambda = (k-1.)/10.;
    p = exp(lambda*r).*(histog'); 
    Z(k) = sum(p*binsize); p = p/Z(k);
    e(k) = sum(r.*p*binsize);
end
lam = (0:(M-1))/10.;
lz = log(Z);

save(sprintf('Feature/naturalStat_GaborS1_LocalFlat.mat'), 'M',...
    'lam', 'e', 'lz', 'Upperbound', 'scale', 'norient', 'histog');

